package org.itscool.weber.tag;

import javax.servlet.jsp.JspException;

import org.itscool.commons.util.JspTagUtil;

/**
 * HTMLの&lt;iframe&gt;タグを生成するタグです。<BR>
 * name属性を指定しない場合はpropertyの値を返します。<BR>
 *（sturtsの場合はStruts設定ファイルでこのフォームに関連づけられたBean
 * に対応するプロパティの値になります。)<BR>
 *<BR>
  *【属性】<BR>
 * <table cellSpacing=0 cellPadding=0 border=1 >
 * <tr>
 *   <td>property（必須）</td>
 *   <td>
 *   サブミット時に送信されるリクエストパラメータ名です。又、サーブレットからフォワード
 *   されたときにnameで指定されたBeanインスタンスに該当するプロパティがセットされます。<br>
 *   name属性が指定されていない場合はpropertyに指定された値をサーバから取得します。<br>
 *   尚、HTMLのname属性にはpropertyに指定した文字列が出力されます。
 *  （ただしoption、link、imgタグは除く）
 *   </td>
 * <tr>
 * <tr>
 *   <td>name</td>
 *   <td>propertyが属するBeanの名前を指定します。</td>
 * </tr>
 * <tr>
 *   <td>htmlname</td>
 *   <td>
 *   HTMLのname属性にpropertyを使用したくない場合は、htmlnameにname属性を指定します。
 *   この属性を指定するとHTML出力時にpropertyではなくhtmlnameの値がname属性として出力されます。
 *   </td>
 * </tr>
 * <tr>
 *   <td>value</td>
 *   <td>このコンポーネントにセットされる初期値</td>
 * </tr>
 * <tr>
 *   <td>style</td>
 *   <td>このコンポーネントのスタイル</td>
 * </tr>
 * <tr>
 *   <td>scope</td>
 *   <td>propertyのスコープ</td>
 * </tr>
 * <tr>
 *   <td>readonly</td>
 *   <td>このコンポーネントの読取属性（trueの場合は読取専用）</td>
 * </tr>
 * <tr>
 *   <td>disabled</td>
 *   <td>このコンポーネントの使用可否属性（falseの場合は使用不可）</td>
 * </tr>
 * <tr>
 *   <td>csclass</td>
 *   <td>このコンポーネントに指定するスタイルシート</td>
 * </tr>
 * <tr>
 *   <td>
 *   onblur<br>
 *   onchange<br>
 *   onclick<br>
 *   ondblclick<br>
 *   onfocus<br>
 *   onkeydown<br>
 *   onkeypress<br>
 *   onkeyup<br>
 *   onmousedown<br>
 *   onmousemove<br>
 *   onmouseout<br>
 *   onmouseover<br>
 *   onmouseup<br>
 *   </td>
 *   <td>
 *    Javaスクリプト
 *   </td>
 * </tr>
 * <tr>
 *   <td>width</td>
 *   <td>このフレームの幅を指定します</td>
 * </tr>
 * <tr>
 *   <td>height</td>
 *   <td>このフレームの高さを指定します</td>
 * </tr>
 * <tr>
 *   <td>targetName</td>
 *   <td>このフレームのターゲット名(name)を指定します</td>
 * </tr>
 * </table>
 * 
 * @author KANO
 * @since jdk1.4.1
 * @version 1.00A 2004/11/1
*/
public class IframeTag extends HtmlTag {
    private String width;
    private String height;
    private String targetName;
    
    /**
     * HTMLの&lt;iframe&gt;タグを生成します<br>
     * scopeが指定されていない場合は、次の順序でオブジェクトを検索します。<br>
     * request, session, contextの順
     * @return int
    */
    public int doStartTag() throws JspException {
		String result =
			(String)JspTagUtil.findProperty(pageContext, name, property, scope);
			
        StringBuffer inputTag = new StringBuffer("<iframe ");
		if( htmlname != null && htmlname.length() > 0 ){
			inputTag.append( JspTagUtil.createAttribute("name", htmlname) );
		}else{
			inputTag.append( JspTagUtil.createAttribute("name", property) );
		}
        inputTag.append(JspTagUtil.createAttribute("src", result));
        inputTag.append(JspTagUtil.createAttribute("width", width));
        inputTag.append(JspTagUtil.createAttribute("height", height));
		inputTag.append(JspTagUtil.createAttribute("style", style));
		inputTag.append(JspTagUtil.createBoolAttribute("readonly", readonly));
		inputTag.append(JspTagUtil.createBoolAttribute("disabled", disabled));
		inputTag.append(JspTagUtil.createBoolAttribute("class", csClass));
        inputTag.append(this.createJavaScriptTag());
        inputTag.append("></iframe>");

        try {
            pageContext.getOut().print(inputTag.toString());
        } catch (Exception e) {
            throw new JspException(e.getMessage());
        }

        return SKIP_BODY;
    }

    public int doEndTag() {
        return EVAL_PAGE;
    }

    /**
     * @return IFrameの高さ
     */
    public String getHeight() {
        return height;
    }

    /**
     * @return IFrameの幅
     */
    public String getWidth() {
        return width;
    }

    /**
     * @param string IFrameの高さ
     */
    public void setHeight(String string) {
        height = string;
    }

    /**
     * @param string IFrameの幅
     */
    public void setWidth(String string) {
        width = string;
    }

    /**
     * @return ターゲット名
     */
    public String getTargetName() {
        return targetName;
    }

    /**
     * @param string ターゲット名
     */
    public void setTargetName(String string) {
        targetName = string;
    }

}
